<?php

#
# Author: Markus Gruenwald
# Url: www.mg-it.net
# Date: 2008-09-13
#

define("_WARNRULE", '#FFFF00');
define("_CRITRULE", '#FF0000');

define("_AREA_IN_OCT", '#99CCFF');
define("_AREA_OUT_OCT", '#CCFFCC');
define("_LINE_IN_OCT", '#999999');
define("_LINE_OUT_OCT", '#999999');

define("_AREA_IN_ERR", '#FF0000');
define("_AREA_OUT_ERR", '#FF00FF');
define("_LINE_IN_ERR", '#999999');
define("_LINE_OUT_ERR", '#999999');

define("_AREA_IN_DIS", '#FF0000');
define("_AREA_OUT_DIS", '#FF00FF');
define("_LINE_IN_DIS", '#999999');
define("_LINE_OUT_DIS", '#999999');

define("_AREA_WRONGDATA", '#FFFFA0');

define("_LINE_IN_BCAST", '#FF0000');
define("_LINE_OUT_BCAST", '#FF8000');

define("_LINE_IN_MCAST", '#0000FF');
define("_LINE_OUT_MCAST", '#00FF00');


$warning = "";
$minimum = "";
$critical = "";
$warning = "";
$vlabel = "";

if ($WARN[1] != "") {
        $warning = $WARN[1];
}
if ($CRIT[1] != "") {
        $critical = $CRIT[1];
}
if ($MIN[1] != "") {
        $lower = " --lower=" . $MIN[1];
        $minimum = $MIN[1];
}
if ($CRIT[1] != "") {
        $upper = " --upper=" . $MAX[1];
        $maximum = $MAX[1];
}
if ($UNIT[1] == "%%") {
        $vlabel = "%";
}
elseif ($UNIT[1] == "c") {
        $vlabel = "Counter";
}
else {
        $vlabel = $UNIT[1];
}

$IF_SPEED = $MAX[1] / 1000000;
if ($IF_SPEED == "100") {
        $IF_SPEED_DESC = "100Mb";
}
elseif ($IF_SPEED == "1000") {
        $IF_SPEED_DESC = "1G";
}
elseif ($MAX[1] == "4294967295") {
        $IF_SPEED_DESC = "10G";
}
elseif ($IF_SPEED == "10000") {
        $IF_SPEED_DESC = "10G";
}
else {
        $IF_SPEED_DESC = "unknown";
}


$ds_name[1] = "IN/OUT bit/s";
$opt[1] = "--vertical-label Bit/s --step 300 --base=1000 --height=200 --title \"$hostname / $servicedesc\" ";

$def[1] = "DEF:inOctAv=$RRDFILE[1]:$DS[1]:AVERAGE " ;
$def[1] .= "DEF:outOctAv=$RRDFILE[2]:$DS[1]:AVERAGE " ;
$def[1] .= "CDEF:outOctAvNeg=outOctAv,-1,* " ;
$def[1] .= "CDEF:wrong1=inOctAv,outOctAv,+,UN,INF,UNKN,IF ";
$def[1] .= "CDEF:wrong2=0,wrong1,- ";
$def[1] .= "AREA:inOctAv" . _AREA_IN_OCT . ":\"$NAME[1] \" ";
$def[1] .= "LINE1:inOctAv" . _LINE_IN_OCT . ":\"\" ";
$def[1] .= "GPRINT:inOctAv:LAST:\"   Current\: %8.2lf %s\" " ;
$def[1] .= "GPRINT:inOctAv:AVERAGE:\"Average\: %8.2lf %s\" " ;
$def[1] .= "GPRINT:inOctAv:MAX:\"Maximium\: %8.2lf %s\\n\" " ;
$def[1] .= "AREA:outOctAvNeg" . _AREA_OUT_OCT . ":\"$NAME[2] \" ";
$def[1] .= "LINE1:outOctAvNeg" . _LINE_OUT_OCT . ":\"\" ";
$def[1] .= "GPRINT:outOctAv:LAST:\"Current\: %8.2lf %s\" " ;
$def[1] .= "GPRINT:outOctAv:AVERAGE:\"Average\: %8.2lf %s\" " ;
$def[1] .= "GPRINT:outOctAv:MAX:\"Maximium\: %8.2lf %s\\l\" ";
$def[1] .= "AREA:wrong1" . _AREA_WRONGDATA . ":\"unknown (device may be down)\\n\" ";
$def[1] .= "AREA:wrong2" . _AREA_WRONGDATA . ":\"\" ";
$def[1] .= 'COMMENT:"\n" ';
$def[1] .= 'COMMENT:"Interface speed\: ' . $IF_SPEED_DESC . '\n" ';
$def[1] .= 'COMMENT:"Using Template\: ' . $TEMPLATE[1] . '\r" ';
$def[1] .= "HRULE:0#000000";


$ds_name[2] = "IN/OUT errors";
$opt[2] = '--vertical-label Counter --step 300"' . '" --title "' . $hostname . ' / ' . $servicedesc . '"' . $lower;

$def[2] = "DEF:inErrAv=$RRDFILE[3]:$DS[1]:AVERAGE " ;
$def[2] .= "DEF:outErrAv=$RRDFILE[4]:$DS[1]:AVERAGE " ;
$def[2] .= "CDEF:outErrAvNeg=outErrAv,-1,* " ;
$def[2] .= "AREA:inErrAv" . _AREA_IN_ERR . ":\"$NAME[3] \" ";
$def[2] .= "LINE1:inErrAv" . _LINE_IN_ERR . ":\"\" ";
$def[2] .= "GPRINT:inErrAv:LAST:\"   Current\: %8.0lf %s\" " ;
$def[2] .= "GPRINT:inErrAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[2] .= "GPRINT:inErrAv:MAX:\"Maximium\: %8.0lf %s\\n\" " ;
$def[2] .= "AREA:outErrAvNeg" . _AREA_OUT_ERR . ":\"$NAME[4] \" ";
$def[2] .= "LINE1:outErrAvNeg" . _LINE_OUT_ERR . ":\"\" ";
$def[2] .= "GPRINT:outErrAv:LAST:\"Current\: %8.0lf %s\" " ;
$def[2] .= "GPRINT:outErrAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[2] .= "GPRINT:outErrAv:MAX:\"Maximium\: %8.0lf %s\\l\" ";



$ds_name[3] = "IN/OUT discards";
$opt[3] = '--vertical-label Counter --step 300"' . '" --title "' . $hostname . ' / ' . $servicedesc . '"' . $lower;

$def[3] = "DEF:inDisAv=$RRDFILE[5]:$DS[1]:AVERAGE " ;
$def[3] .= "DEF:outDisAv=$RRDFILE[6]:$DS[1]:AVERAGE " ;
$def[3] .= "CDEF:outDisAvNeg=outDisAv,-1,* " ;
$def[3] .= "AREA:inDisAv" . _AREA_IN_DIS . ":\"$NAME[5] \" ";
$def[3] .= "LINE1:inDisAv" . _LINE_IN_DIS . ":\"\" ";
$def[3] .= "GPRINT:inDisAv:LAST:\"   Current\: %8.0lf %s\" " ;
$def[3] .= "GPRINT:inDisAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[3] .= "GPRINT:inDisAv:MAX:\"Maximium\: %8.0lf %s\\n\" " ;
$def[3] .= "AREA:outDisAvNeg" . _AREA_OUT_DIS . ":\"$NAME[6] \" ";
$def[3] .= "LINE1:outDisAvNeg" . _LINE_OUT_DIS . ":\"\" ";
$def[3] .= "GPRINT:outDisAv:LAST:\"Current\: %8.0lf %s\" " ;
$def[3] .= "GPRINT:outDisAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[3] .= "GPRINT:outDisAv:MAX:\"Maximium\: %8.0lf %s\\l\" ";



$ds_name[4] = "broadcasts/multicasts";
$opt[4] = '--vertical-label Counter --step 300"' . '" --title "' . $hostname . ' / ' . $servicedesc . '"' . $lower;

$def[4] = "DEF:inBcastAv=$RRDFILE[7]:$DS[1]:AVERAGE " ;
$def[4] .= "DEF:outBcastAv=$RRDFILE[8]:$DS[1]:AVERAGE " ;
$def[4] .= "CDEF:outBcastAvNeg=outBcastAv,-1,* " ;
$def[4] .= "DEF:inMcastAv=$RRDFILE[9]:$DS[1]:AVERAGE " ;
$def[4] .= "DEF:outMcastAv=$RRDFILE[10]:$DS[1]:AVERAGE " ;
$def[4] .= "CDEF:outMcastAvNeg=outMcastAv,-1,* " ;

$def[4] .= "LINE2:inBcastAv" . _LINE_IN_BCAST . ":\"$NAME[7] \" ";
$def[4] .= "GPRINT:inBcastAv:LAST:\"   Current\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:inBcastAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:inBcastAv:MAX:\"Maximium\: %8.0lf %s\\n\" " ;

$def[4] .= "LINE2:outBcastAvNeg" . _LINE_OUT_BCAST . ":\"$NAME[8] \" ";
$def[4] .= "GPRINT:outBcastAv:LAST:\"Current\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:outBcastAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:outBcastAv:MAX:\"Maximium\: %8.0lf %s\\l\" ";

$def[4] .= "LINE2:inMcastAv" . _LINE_IN_MCAST . ":\"$NAME[9] \" ";
$def[4] .= "GPRINT:inMcastAv:LAST:\"   Current\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:inMcastAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:inMcastAv:MAX:\"Maximium\: %8.0lf %s\\n\" " ;

$def[4] .= "LINE2:outMcastAvNeg" . _LINE_OUT_MCAST . ":\"$NAME[10] \" ";
$def[4] .= "GPRINT:outMcastAv:LAST:\"Current\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:outMcastAv:AVERAGE:\"Average\: %8.0lf %s\" " ;
$def[4] .= "GPRINT:outMcastAv:MAX:\"Maximium\: %8.0lf %s\\l\" ";
$def[4] .= "HRULE:0#000000";

?>
